package org.teiid.translator.cleaner;

import org.teiid.language.QueryExpression;
import org.teiid.metadata.RuntimeMetadata;
import org.teiid.translator.*;

import java.util.List;

/**
 *Delegating Translator for cleaning data
 *Teiid 8.4 CR2
 *June 12, 2013 
 **/

@Translator(name="cleaner")
public class cleaner extends BaseDelegatingExecutionFactory<Object, Object> {
	
	
    @Override
    public ResultSetExecution createResultSetExecution(QueryExpression command, ExecutionContext executionContext, RuntimeMetadata metadata, Object connection) throws TranslatorException {
    	
    	System.out.println("Inside createResultSetExecution");

        final ResultSetExecution rse = super.createResultSetExecution(command, executionContext, metadata, connection);

        return new ResultSetExecution() {

            /*
             * Returning the next row of results into a list
             * First iteration, printing out the index of item "new york" in the list
             */

            @Override
            public List<?> next() throws TranslatorException, DataNotAvailableException {
            	System.out.println("Hello-before list");
                List<?> row = rse.next();
                int index = row.indexOf("New York");  
                System.out.println("index of new york: " + index);  
                //edit the row
                return row;
            }

            @Override
            public void close() {
                rse.close();
            }

            @Override
            public void cancel() throws TranslatorException {
                rse.cancel();

            }

            @Override
            public void execute() throws TranslatorException {
                rse.execute();
            }
        };

      	
        


    }
    
   	
}
